diff --git a/gcc/c/c-typeck.c b/gcc/c/c-typeck.c
index 46b2e68..75156fa 100644
--- a/gcc/c/c-typeck.c
+++ b/gcc/c/c-typeck.c
@@ -2906,11 +2906,12 @@ c_expr_sizeof_expr (location_t loc, struct c_expr expr)
       if (TREE_CODE (expr.value) == PARM_DECL
 	  && C_ARRAY_PARAMETER (expr.value))
 	{
-	  if (warning_at (loc, OPT_Wsizeof_array_argument,
-			  "%<sizeof%> on array function parameter %qE will "
-			  "return size of %qT", expr.value,
-			  TREE_TYPE (expr.value)))
-	    inform (DECL_SOURCE_LOCATION (expr.value), "declared here");
+	  diagnostic_group d;
+	  if (d.warning_at (loc, OPT_Wsizeof_array_argument,
+			    "%<sizeof%> on array function parameter %qE will "
+			    "return size of %qT", expr.value,
+			    TREE_TYPE (expr.value)))
+	    d.inform (DECL_SOURCE_LOCATION (expr.value), "declared here");
 	}
       tree folded_expr = c_fully_fold (expr.value, require_constant_value,
 				       &expr_const_operands);
@@ -3735,19 +3736,27 @@ parser_build_binary_op (location_t location, enum tree_code code,
 		    "comparison with string literal results in unspecified behavior");
       /* Warn for ptr == '\0', it's likely that it should've been ptr[0].  */
       if (POINTER_TYPE_P (type1)
-	   && null_pointer_constant_p (arg2.value)
-	   && char_type_p (type2)
-	   && warning_at (location, OPT_Wpointer_compare,
-			  "comparison between pointer and zero character "
-			  "constant"))
-	inform (arg1.get_start (), "did you mean to dereference the pointer?");
+	  && null_pointer_constant_p (arg2.value)
+	  && char_type_p (type2))
+	{
+	  diagnostic_group d;
+	  if (d.warning_at (location, OPT_Wpointer_compare,
+			    "comparison between pointer and zero character "
+			    "constant"))
+	    d.inform (arg1.get_start (),
+		      "did you mean to dereference the pointer?");
+	}
       else if (POINTER_TYPE_P (type2)
 	       && null_pointer_constant_p (arg1.value)
-	       && char_type_p (type1)
-	       && warning_at (location, OPT_Wpointer_compare,
-			      "comparison between pointer and zero character "
-			      "constant"))
-	inform (arg2.get_start (), "did you mean to dereference the pointer?");
+	       && char_type_p (type1))
+	{
+	  diagnostic_group d;
+	  if (d.warning_at (location, OPT_Wpointer_compare,
+			    "comparison between pointer and zero character "
+			    "constant"))
+	    d.inform (arg2.get_start (),
+		      "did you mean to dereference the pointer?");
+	}
     }
   else if (TREE_CODE_CLASS (code) == tcc_comparison
 	   && (code1 == STRING_CST || code2 == STRING_CST))
@@ -4288,13 +4297,16 @@ build_unary_op (location_t location, enum tree_code code, tree xarg,
 	    e = TREE_OPERAND (e, 1);
 
 	  if ((TREE_CODE (TREE_TYPE (arg)) == BOOLEAN_TYPE
-	       || truth_value_p (TREE_CODE (e)))
-	      && warning_at (location, OPT_Wbool_operation,
-			     "%<~%> on a boolean expression"))
+	       || truth_value_p (TREE_CODE (e))))
 	    {
-	      gcc_rich_location richloc (location);
-	      richloc.add_fixit_insert_before (location, "!");
-	      inform (&richloc, "did you mean to use logical not?");
+	      diagnostic_group d;
+	      if (d.warning_at (location, OPT_Wbool_operation,
+				"%<~%> on a boolean expression"))
+		{
+		  gcc_rich_location richloc (location);
+		  richloc.add_fixit_insert_before (location, "!");
+		  d.inform (&richloc, "did you mean to use logical not?");
+		}
 	    }
 	  if (!noconvert)
 	    arg = default_conversion (arg);
@@ -6197,11 +6209,13 @@ error_init (location_t loc, const char *gmsgid)
 {
   char *ofwhat;
 
+  diagnostic_group d;
+
   /* The gmsgid may be a format string with %< and %>. */
-  error_at (loc, gmsgid);
+  d.error_at (loc, gmsgid);
   ofwhat = print_spelling ((char *) alloca (spelling_length () + 1));
   if (*ofwhat)
-    inform (loc, "(near initialization for %qs)", ofwhat);
+    d.inform (loc, "(near initialization for %qs)", ofwhat);
 }
 
 /* Issue a pedantic warning for a bad initializer component.  OPT is
@@ -6216,15 +6230,14 @@ pedwarn_init (location_t loc, int opt, const char *gmsgid, ...)
      it was defined to make sure macros defined in system headers
      but used incorrectly elsewhere are diagnosed.  */
   source_location exploc = expansion_point_location_if_in_system_header (loc);
-
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
-  bool warned = emit_diagnostic_valist (DK_PEDWARN, exploc, opt, gmsgid, &ap,
-					NULL);
+  bool warned = d.emit_diagnostic_valist (DK_PEDWARN, exploc, opt, gmsgid, &ap);
   va_end (ap);
   char *ofwhat = print_spelling ((char *) alloca (spelling_length () + 1));
   if (*ofwhat && warned)
-    inform (exploc, "(near initialization for %qs)", ofwhat);
+    d.inform (exploc, "(near initialization for %qs)", ofwhat);
 }
 
 /* Issue a warning for a bad initializer component.
@@ -6239,16 +6252,18 @@ warning_init (location_t loc, int opt, const char *gmsgid)
   char *ofwhat;
   bool warned;
 
+  diagnostic_group d;
+
   /* Use the location where a macro was expanded rather than where
      it was defined to make sure macros defined in system headers
      but used incorrectly elsewhere are diagnosed.  */
   source_location exploc = expansion_point_location_if_in_system_header (loc);
 
   /* The gmsgid may be a format string with %< and %>. */
-  warned = warning_at (exploc, opt, gmsgid);
+  warned = d.warning_at (exploc, opt, gmsgid);
   ofwhat = print_spelling ((char *) alloca (spelling_length () + 1));
   if (*ofwhat && warned)
-    inform (exploc, "(near initialization for %qs)", ofwhat);
+    d.inform (exploc, "(near initialization for %qs)", ofwhat);
 }
 
 /* If TYPE is an array type and EXPR is a parenthesized string
@@ -6289,14 +6304,15 @@ get_fndecl_argument_location (tree fndecl, int argnum)
   return DECL_SOURCE_LOCATION (param);
 }
 
-/* Issue a note about a mismatching argument for parameter PARMNUM
+/* Issue a note within GROUP about a mismatching argument for parameter PARMNUM
    to FUNDECL, for types EXPECTED_TYPE and ACTUAL_TYPE.
    Attempt to issue the note at the pertinent parameter of the decl;
    failing that issue it at the location of FUNDECL; failing that
    issue it at PLOC.  */
 
 static void
-inform_for_arg (tree fundecl, location_t ploc, int parmnum,
+inform_for_arg (diagnostic_group *group,
+		tree fundecl, location_t ploc, int parmnum,
 		tree expected_type, tree actual_type)
 {
   location_t loc;
@@ -6305,9 +6321,9 @@ inform_for_arg (tree fundecl, location_t ploc, int parmnum,
   else
     loc = ploc;
 
-  inform (loc,
-	  "expected %qT but argument is of type %qT",
-	  expected_type, actual_type);
+  group->inform (loc,
+		 "expected %qT but argument is of type %qT",
+		 expected_type, actual_type);
 }
 
 /* Convert value RHS to type TYPE as preparation for an assignment to
@@ -6380,8 +6396,11 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
     switch (errtype)                                                     \
       {                                                                  \
       case ic_argpass:                                                   \
-        if (pedwarn (PLOC, OPT, AR, parmnum, rname))			 \
-          inform_for_arg (fundecl, (PLOC), parmnum, type, rhstype);	\
+	{								\
+	  diagnostic_group d;						\
+	  if (d.pedwarn (PLOC, OPT, AR, parmnum, rname))		\
+	    inform_for_arg (&d, fundecl, (PLOC), parmnum, type, rhstype); \
+	}								\
         break;                                                           \
       case ic_assign:                                                    \
         pedwarn (LOCATION, OPT, AS);                                     \
@@ -6406,8 +6425,11 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
     switch (errtype)                                                     \
       {                                                                  \
       case ic_argpass:                                                   \
-        if (pedwarn (PLOC, OPT, AR, parmnum, rname, QUALS))		 \
-          inform_for_arg (fundecl, (PLOC), parmnum, type, rhstype);	\
+	{								\
+	diagnostic_group d;						\
+	if (d.pedwarn (PLOC, OPT, AR, parmnum, rname, QUALS))		\
+	  inform_for_arg (&d, fundecl, (PLOC), parmnum, type, rhstype);	\
+	}								\
         break;                                                           \
       case ic_assign:                                                    \
         pedwarn (LOCATION, OPT, AS, QUALS);				 \
@@ -6432,8 +6454,11 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
     switch (errtype)                                                     \
       {                                                                  \
       case ic_argpass:                                                   \
-        if (warning_at (PLOC, OPT, AR, parmnum, rname, QUALS))           \
-          inform_for_arg (fundecl, (PLOC), parmnum, type, rhstype);      \
+	{								\
+	  diagnostic_group d;						\
+	  if (d.warning_at (PLOC, OPT, AR, parmnum, rname, QUALS))	\
+	    inform_for_arg (&d, fundecl, (PLOC), parmnum, type, rhstype); \
+	}								\
         break;                                                           \
       case ic_assign:                                                    \
         warning_at (LOCATION, OPT, AS, QUALS);                           \
@@ -6925,13 +6950,17 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
 		switch (errtype)
 		  {
 		  case ic_argpass:
-		    if (pedwarn (expr_loc, OPT_Wpointer_sign,
-				 "pointer targets in passing argument %d of "
-				 "%qE differ in signedness", parmnum, rname))
-		      inform ((fundecl && !DECL_IS_BUILTIN (fundecl))
-			      ? DECL_SOURCE_LOCATION (fundecl) : expr_loc,
-			      "expected %qT but argument is of type %qT",
-			      type, rhstype);
+		    {
+		      diagnostic_group d;
+		      if (d.pedwarn (expr_loc, OPT_Wpointer_sign,
+				     "pointer targets in passing argument %d "
+				     "of %qE differ in signedness", parmnum,
+				     rname))
+			d.inform ((fundecl && !DECL_IS_BUILTIN (fundecl))
+				  ? DECL_SOURCE_LOCATION (fundecl) : expr_loc,
+				  "expected %qT but argument is of type %qT",
+				  type, rhstype);
+		    }
 		    break;
 		  case ic_assign:
 		    pedwarn (location, OPT_Wpointer_sign,
@@ -6982,10 +7011,14 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
 	  switch (errtype)
 	    {
 	    case ic_argpass:
-	      if (pedwarn (expr_loc, OPT_Wincompatible_pointer_types,
-			   "passing argument %d of %qE from incompatible "
-			   "pointer type", parmnum, rname))
-		inform_for_arg (fundecl, expr_loc, parmnum, type, rhstype);
+	      {
+		diagnostic_group d;
+		if (d.pedwarn (expr_loc, OPT_Wincompatible_pointer_types,
+			       "passing argument %d of %qE from incompatible "
+			       "pointer type", parmnum, rname))
+		  inform_for_arg (&d, fundecl, expr_loc, parmnum, type,
+				  rhstype);
+	      }
 	      break;
 	    case ic_assign:
 	      pedwarn (location, OPT_Wincompatible_pointer_types,
@@ -7025,10 +7058,13 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
 	switch (errtype)
 	  {
 	  case ic_argpass:
-	    if (pedwarn (expr_loc, OPT_Wint_conversion,
-			 "passing argument %d of %qE makes pointer from "
-			 "integer without a cast", parmnum, rname))
-	      inform_for_arg (fundecl, expr_loc, parmnum, type, rhstype);
+	    {
+	      diagnostic_group d;
+	      if (d.pedwarn (expr_loc, OPT_Wint_conversion,
+			     "passing argument %d of %qE makes pointer from "
+			     "integer without a cast", parmnum, rname))
+		inform_for_arg (&d, fundecl, expr_loc, parmnum, type, rhstype);
+	    }
 	    break;
 	  case ic_assign:
 	    pedwarn (location, OPT_Wint_conversion,
@@ -7056,10 +7092,13 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
       switch (errtype)
 	{
 	case ic_argpass:
-	  if (pedwarn (expr_loc, OPT_Wint_conversion,
-		       "passing argument %d of %qE makes integer from "
-		       "pointer without a cast", parmnum, rname))
-	    inform_for_arg (fundecl, expr_loc, parmnum, type, rhstype);
+	  {
+	    diagnostic_group d;
+	    if (d.pedwarn (expr_loc, OPT_Wint_conversion,
+			   "passing argument %d of %qE makes integer from "
+			   "pointer without a cast", parmnum, rname))
+	      inform_for_arg (&d, fundecl, expr_loc, parmnum, type, rhstype);
+	  }
 	  break;
 	case ic_assign:
 	  pedwarn (location, OPT_Wint_conversion,
@@ -7095,9 +7134,12 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
   switch (errtype)
     {
     case ic_argpass:
-      error_at (expr_loc, "incompatible type for argument %d of %qE", parmnum,
-		rname);
-      inform_for_arg (fundecl, expr_loc, parmnum, type, rhstype);
+      {
+	diagnostic_group d;
+	d.error_at (expr_loc, "incompatible type for argument %d of %qE",
+		    parmnum, rname);
+	inform_for_arg (&d, fundecl, expr_loc, parmnum, type, rhstype);
+      }
       break;
     case ic_assign:
       error_at (location, "incompatible types when assigning to type %qT from "
diff --git a/gcc/calls.c b/gcc/calls.c
index 384c023..c929fdc 100644
--- a/gcc/calls.c
+++ b/gcc/calls.c
@@ -1773,38 +1773,40 @@ maybe_warn_nonstring_arg (tree fndecl, tree exp)
 
       bool warned = false;
 
+      diagnostic_group d;
       if (wi::ltu_p (asize, wibnd))
 	{
 	  if (bndrng[0] == bndrng[1])
-	    warned = warning_at (loc, OPT_Wstringop_overflow_,
-				 "%qD argument %i declared attribute "
-				 "%<nonstring%> is smaller than the specified "
-				 "bound %wu",
-				 fndecl, argno + 1, wibnd.to_uhwi ());
+	    warned = d.warning_at (loc, OPT_Wstringop_overflow_,
+				   "%qD argument %i declared attribute "
+				   "%<nonstring%> is smaller than the "
+				   "specified bound %wu",
+				   fndecl, argno + 1, wibnd.to_uhwi ());
 	  else if (wi::ltu_p (asize, wi::to_offset (bndrng[0])))
-	    warned = warning_at (loc, OPT_Wstringop_overflow_,
-				 "%qD argument %i declared attribute "
-				 "%<nonstring%> is smaller than "
-				 "the specified bound [%E, %E]",
-				 fndecl, argno + 1, bndrng[0], bndrng[1]);
+	    warned = d.warning_at (loc, OPT_Wstringop_overflow_,
+				   "%qD argument %i declared attribute "
+				   "%<nonstring%> is smaller than "
+				   "the specified bound [%E, %E]",
+				   fndecl, argno + 1, bndrng[0], bndrng[1]);
 	  else
-	    warned = warning_at (loc, OPT_Wstringop_overflow_,
-				 "%qD argument %i declared attribute "
-				 "%<nonstring%> may be smaller than "
-				 "the specified bound [%E, %E]",
-				 fndecl, argno + 1, bndrng[0], bndrng[1]);
+	    warned = d.warning_at (loc, OPT_Wstringop_overflow_,
+				   "%qD argument %i declared attribute "
+				   "%<nonstring%> may be smaller than "
+				   "the specified bound [%E, %E]",
+				   fndecl, argno + 1, bndrng[0], bndrng[1]);
 	}
       else if (fncode == BUILT_IN_STRNCAT)
 	; /* Avoid warning for calls to strncat() when the bound
 	     is equal to the size of the non-string argument.  */
       else if (!bound)
-	warned = warning_at (loc, OPT_Wstringop_overflow_,
-			     "%qD argument %i declared attribute %<nonstring%>",
-			     fndecl, argno + 1);
+	warned = d.warning_at (loc, OPT_Wstringop_overflow_,
+			       "%qD argument %i declared attribute "
+			       "%<nonstring%>",
+			       fndecl, argno + 1);
 
       if (warned)
-	inform (DECL_SOURCE_LOCATION (decl),
-		"argument %qD declared here", decl);
+	d.inform (DECL_SOURCE_LOCATION (decl),
+		  "argument %qD declared here", decl);
     }
 }
 
diff --git a/gcc/cgraphunit.c b/gcc/cgraphunit.c
index 462e247..adea1b3 100644
--- a/gcc/cgraphunit.c
+++ b/gcc/cgraphunit.c
@@ -1357,20 +1357,24 @@ maybe_diag_incompatible_alias (tree alias, tree target)
       if (ifunc)
 	{
 	  funcptr = build_pointer_type (funcptr);
-
-	  if (warning_at (DECL_SOURCE_LOCATION (target),
-			  OPT_Wattribute_alias,
-			  "%<ifunc%> resolver for %qD should return %qT",
-			  alias, funcptr))
-	    inform (DECL_SOURCE_LOCATION (alias),
-		    "resolver indirect function declared here");
+	  diagnostic_group d;
+	  if (d.warning_at (DECL_SOURCE_LOCATION (target),
+			    OPT_Wattribute_alias,
+			    "%<ifunc%> resolver for %qD should return %qT",
+			    alias, funcptr))
+	    d.inform (DECL_SOURCE_LOCATION (alias),
+		      "resolver indirect function declared here");
+	}
+      else
+	{
+	  diagnostic_group d;
+	  if (d.warning_at (DECL_SOURCE_LOCATION (alias),
+			    OPT_Wattribute_alias,
+			    "%qD alias between functions of incompatible "
+			    "types %qT and %qT", alias, altype, targtype))
+	    d.inform (DECL_SOURCE_LOCATION (target),
+		      "aliased declaration here");
 	}
-      else if (warning_at (DECL_SOURCE_LOCATION (alias),
-			   OPT_Wattribute_alias,
-			   "%qD alias between functions of incompatible "
-			   "types %qT and %qT", alias, altype, targtype))
-	inform (DECL_SOURCE_LOCATION (target),
-		"aliased declaration here");
     }
 }
 
